package my_event;

import java.io.*;
import org.omg.CORBA.*;

import org.omg.CosEventChannelAdmin.*;
import org.omg.CosEventComm.*;
import org.omg.CosNaming.*;


class Consommateur implements PushConsumerOperations
{
  public Consommateur()
  {
  }

  public void disconnect_push_consumer()
  {
    System.out.println("Consumer disconnected.");
  }
		
  public synchronized void push(org.omg.CORBA.Any data)
    throws org.omg.CosEventComm.Disconnected
  {
    System.out.println("event :  " + data.extract_string());
  }
}

public class Consommer 
{
  public static void main( String args[] ) 
  {
    EventChannel ecs = null;
    ConsumerAdmin ca = null;
    PushConsumer pushConsumer = null;
    ProxyPushSupplier pps = null;

    try 
      {
        //Initialisation de l'ORB.
        ORB orb = ORB.init( args, null );
								
        org.omg.PortableServer.POA poa =
          org.omg.PortableServer.POAHelper.narrow(
                                                  orb.resolve_initial_references("RootPOA"));
        poa.the_POAManager().activate();

        // Rcupration du Main Service
        NamingContextExt nc = 	
          NamingContextExtHelper.narrow(orb.resolve_initial_references("NameService"));

        // Rcupration du canal d'vnement
        ecs = EventChannelHelper.narrow(nc.resolve(
                                                   nc.to_name("eventchannel.example")));

								
        // On obtient les proxy des fournisseurs
        ca  = ecs.for_consumers();
        pps = ca.obtain_push_supplier();

        // Cration du consommateur (comme un servant on obtient la rfrence
        // a un objet CORBA
        PushConsumerPOATie pt = new PushConsumerPOATie( new Consommateur() );
        pt._this_object(orb);
        pushConsumer = PushConsumerHelper.narrow(poa.servant_to_reference(pt) );

        // On connecte le consommateur au proxy des fournisseurs suivant le modle push
        pps.connect_push_consumer( pushConsumer );
								
        System.out.println("PushConsumerImpl registered.");
        orb.run();

      }
    catch( Exception ex ) 
      {
        ex.printStackTrace();
      }
  }
}

